extern crate nom;
use nom::{
  IResult,
  Err,
  error::ErrorKind,
  error::Error,
  bytes::complete::{tag, take_while_m_n},
  combinator::map_res,
  sequence::tuple,
  number::complete::hex_u32
};
use std::io::{self, Write};

fn check_flag(input: &[u8]) -> IResult<&[u8], bool> {
    let (input, _) = tag("flag{")(input)?;
    let (input, num) = hex_u32(input)?;
    if num != 0x56b21bba {
        return Err(Err::Error(Error::new(input, ErrorKind::IsA)));
    }
    let (input, num) = hex_u32(input)?;
    if num != 0x72b9f906 {
        return Err(Err::Error(Error::new(input, ErrorKind::IsA)));
    }
    let (input, _) = tag("}")(input)?;
    return Ok((input, true));
}

fn main() {
    let mut input = String::new();
    print!("Enter the flag >> ");
    let _ = io::stdout().flush();
    io::stdin().read_line(&mut input).expect("Error reading from STDIN");
    match check_flag(input.strip_suffix("\n").expect("Error stripping newline").as_bytes()) {
        Ok(_) => println!("Valid Flag!"),
        Err(_) => println!("Invalid Flag!"),
    };

}
